Aspects and aspect types in Knowledge Catalog (formerly Dataplex Universal Catalog) let you add structured metadata to entries, columns, and entry links to describe your data assets and their relationships. This context improves data discoverability and helps you classify sensitive information, such as personally identifiable information (PII), to apply data quality or access policies.
For conceptual information about aspect schemas, system versus custom aspect types, target levels, and data residency constraints, see About aspects and aspect types. For an architectural overview of the entire metadata metamodel, see About metadata in Knowledge Catalog. If this is your first time working with Knowledge Catalog metadata, see the Add metadata to a BigQuery table or Create and use a business glossary quickstarts.
Before you begin
Before you create and manage aspect types and aspects, complete the tasks described in this section.
Required roles
To get the permissions that you need to create and manage aspect types and aspects, ask your administrator to grant you the following IAM roles on the project. You don't need all of these roles simultaneously; choose the role or combination that matches your specific workflow:
To get the permissions that you need to create and manage aspect types and aspects, ask your administrator to grant you the following IAM roles on the project:
-
To manage all catalog resources, including aspect types and entries, with broad administrator access:
Dataplex Catalog Admin (
roles/dataplex.catalogAdmin) or Dataplex Catalog Editor (roles/dataplex.catalogEditor) -
To create and manage custom aspect types only, with least-privilege access for aspect type administrators:
Dataplex Aspect Type Owner (
roles/dataplex.aspectTypeOwner) -
To use aspect types when creating or modifying entries, with least-privilege access for data curators:
Dataplex Aspect Type User (
roles/dataplex.aspectTypeUser) -
To attach reusable system aspect types, such as
schema,contacts, andoverview, to entries and entry links: Dataplex Entry and EntryLink Owner (roles/dataplex.entryOwner) -
To view aspect types and their IAM policies without modifying them:
Dataplex Catalog Viewer (
roles/dataplex.catalogViewer)
For more information about granting roles, see Manage access to projects, folders, and organizations.
These predefined roles contain the permissions required to create and manage aspect types and aspects. To see the exact permissions that are required, expand the Required permissions section:
Required permissions
The following permissions are required to create and manage aspect types and aspects:
-
Create, view, list, update, and delete aspect types:
-
dataplex.aspectTypes.create -
dataplex.aspectTypes.get -
dataplex.aspectTypes.list -
dataplex.aspectTypes.update -
dataplex.aspectTypes.delete
-
-
Use aspect types to enrich entries:
dataplex.aspectTypes.use -
Create, view, update, and delete entries and their aspects:
-
dataplex.entries.create -
dataplex.entries.get -
dataplex.entries.list -
dataplex.entries.update -
dataplex.entries.delete
-
-
Create, view, update, and delete entry links and their aspects:
-
dataplex.entryLinks.create -
dataplex.entryLinks.get -
dataplex.entryLinks.list -
dataplex.entryLinks.update -
dataplex.entryLinks.delete
-
You might also be able to get these permissions with custom roles or other predefined roles.
For more information, see Knowledge Catalog IAM roles.
Enable the API
Enable the Dataplex API in your Knowledge Catalog project. If you are using a new Google Cloud project or a project in which the BigQuery API is enabled, the Dataplex API is enabled by default.
Create a custom aspect type
Console
To create a custom aspect type in the Google Cloud console, follow these subtasks:
Configure basic details:
In the Google Cloud console, go to the Knowledge Catalog Metadata types page.
Click the Aspect types > Custom tab, and then click Create aspect type.
In the Details section, enter the following:
- Optional: Display name: A user-friendly name for the aspect type.
- Aspect type ID: A unique identifier for the aspect type.
- Optional: Description: A description of the aspect type and its purpose.
- Location: Select a location for the aspect type. You can't modify the location after creation. For guidance on global versus regional location tradeoffs, see Custom aspect types.
Define the schema template:
The template defines the format and schema of the metadata fields grouped within your aspect type. You can define fields manually or accelerate schema creation by selecting a starter template from the Template gallery, such as Data Sensitivity, Data Governance, or Data Ingestion. For example, selecting the Data Sensitivity template automatically adds the boolean fields
Is EncryptedandHas PII, and the enum fieldPII Type.To define fields manually:
- In the Template section, click Add field.
- In the New field panel, specify the following:
- Name: An identifier for the field.
- Optional: Display name: A user-friendly label.
- Optional: Description: A brief description of the field.
- Type: Select the field data type. Supported types include Text, Integer, Boolean, Date and Time, Double, Enum, Array, Map, and Record.
- Optional: Is required: Select this checkbox to make the field mandatory when users attach this aspect.
- Click Done. To add more fields, click Add field and repeat these steps.
Add resource labels and save:
Resource labels are arbitrary key-value pairs that help you organize and filter your Google Cloud resources. For example, you can organize resources by environment or team ownership using labels such as
environment: productionorteam: analytics.- In the Labels section, click Add label.
- Enter the label Key and Value.
- Click Save.
gcloud
To create a custom aspect type, use the gcloud dataplex aspect-types
create command.
C#
C#
Before trying this sample, follow the C# setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog C# API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Go
Go
Before trying this sample, follow the Go setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Go API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Java
Java
Before trying this sample, follow the Java setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Java API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Node.js
Node.js
Before trying this sample, follow the Node.js setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Node.js API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Python
Python
Before trying this sample, follow the Python setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Python API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Ruby
Ruby
Before trying this sample, follow the Ruby setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Ruby API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
REST
To create a custom aspect type, use the
aspectType.create
method.
After you create a custom aspect type, you can add aspects to entries.
Example for using the Record ID and Record reference fields
You can use the Record ID and Record reference fields for recursive references. The following example shows how to use these fields:
Consider an aspect type called Employee, with the following fields:
- Name (type:
Text) - Start date (type:
Date & time) - Designation (type:
Text) - Current address (type:
Record) - Permanent address (type:
Record)
The two address fields Current address and Permanent address are of the same
data type Record. To avoid duplication, you can set the Record ID and
Record reference values when defining these fields.
When you define the field Current address, you can specify Record ID as
address-field. For Permanent address, you can specify the same value
(address-field) for Record reference. For example:
- Name (type:
Text) - Start date (type:
Date & time) - Designation (type:
Text) - Current address (type:
Record, Record ID:address-field) - Permanent address (type:
Record, Record reference:address-field)
This way, you don't need to duplicate the fields of another address.
Add aspects to an entry
After you create a custom aspect type, you can create aspects of that type. To add aspects to an entry, you must update the entry, as aspects are stored within entries.
Note the following limitations:
- You can add aspects to an entry or to the columns of an entry.
- You can edit the required aspects only for custom entries. You can't delete the required aspects.
- You can edit and delete the optional aspects for both custom entries and system entries.
- When you replace or reload a BigQuery table using a
CREATE OR REPLACE TABLEstatement, aTRUNCATE TABLEstatement, or aWRITE_TRUNCATEjob, Knowledge Catalog preserves the entry's user-attached aspects. Column-level aspects are also preserved for columns that remain in the schema. However, if you drop and recreate a table using aDROP TABLEstatement and aCREATE TABLEstatement, Knowledge Catalog creates a new entry without the original table's user-attached aspects. To keep aspects when reloading a table, useCREATE OR REPLACE TABLE,TRUNCATE TABLE, orWRITE_TRUNCATE. Alternatively, you can create a BigQuery view and attach aspects to the view.
Console
In the Google Cloud console, go to the Knowledge Catalog Search page.
Search for the entry that you want to add aspects to, and click the entry. The entry details page opens.
On the entry details page, click the Details tab.
In the Aspects section, click Add in the Required aspects or Optional aspects area. You can add required aspects only if the entry type defines required aspects.
Search for and select the aspect that you want to add.
In the Add aspect window, enter the values for the fields.
Click Save.
To add aspects to a column of the entry:
- On the entry details page, click the Schema tab.
- Select the columns to which you want to add aspects.
- Click Add aspect.
- Search for and select the aspect that you want to add.
- In the Add aspect window, enter the values for the fields.
- Click Save.
gcloud
To add aspects to an entry or to a column of an entry, use the gcloud
dataplex entries update
command.
C#
C#
Before trying this sample, follow the C# setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog C# API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
To add aspects to the entry object, see Aspects.
Go
Go
Before trying this sample, follow the Go setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Go API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
To add aspects to the entry object, see Entry.
Java
Java
Before trying this sample, follow the Java setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Java API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Node.js
Node.js
Before trying this sample, follow the Node.js setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Node.js API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Python
Python
Before trying this sample, follow the Python setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Python API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Ruby
Ruby
Before trying this sample, follow the Ruby setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Ruby API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
To add aspects to the entry object, see #required_aspects=.
REST
To add aspects to an entry or to a column of an entry, use the
entry.patch
method.
Creating and using aspects in an entry where the respective aspect type and the entry are in different Google Cloud organizations isn't supported.
Attach aspects of reusable system aspect types
Knowledge Catalog provides predefined system aspect types that you can attach to entries to capture standardized metadata. For example, you can use these aspect types to record ownership contacts, schema definitions, usage metrics, and data quality results.
General workflow and payload rules
When attaching aspects of reusable system aspect types, follow these rules:
- Console versus CLI/REST: For aspect types without nested fields, such as
generic, you can use the Google Cloud console, thegcloudCLI, or the REST API. For aspect types with complex or nested structures, such asdata-quality-scorecard,contacts, ordata-profile, you must use thegcloudCLI or the REST API. - Payload structure:
gcloudCLI: Pass the aspect map directly, keyed by the global aspect type identifier:{"dataplex-types.global.<ASPECT_TYPE>": {"data": { ... }}}.- REST API: Wrap the aspect map inside an
"aspects"container object:{"aspects": {"dataplex-types.global.<ASPECT_TYPE>": {"data": { ... }}}}.
- Overwrite behavior: Updating an aspect replaces any existing data for that specific aspect type on the target entry or column; it does not merge fields.
The following sections provide examples and schemas for attaching common reusable system aspects, beginning with the data quality scorecard.
Data quality scorecard
A data quality scorecard is an aspect that provides a summary of data quality,
often based on data quality scans or other processes. You can attach a data
quality scorecard to an entry to provide custom data quality information. To do
so, attach an aspect of the system-defined type data-quality-scorecard.
The data field within the data-quality-scorecard aspect can include the
following fields:
job: Optional. A record containing details about the job that generated the scorecard.name: The resource name of the data quality job.runTime: The run time of the data quality job.
score: Optional. The overall data quality score. The score ranges between [0, 100].status: Required. The status of the data quality scorecard, indicating if it passed or failed the quality threshold (PASSorFAIL).dimensions: Optional. An array of dimension results. Each result includes:name: The name of the dimension. This can be one ofACCURACY,COMPLETENESS,CONSISTENCY,FRESHNESS,UNIQUENESS,VALIDITY, orVOLUME, or a custom dimension name. Custom dimension names must use uppercase letters and be 30 characters or less.score: The overall dimension-level score, ranging from [0, 100].status: The status of the dimension, indicating if it passed or failed the quality threshold (PASSorFAIL).
columns: Optional. An array of column results. Each result includes:name: The name of the column.score: The overall column-level score, ranging from [0, 100].status: The status of the column, indicating if it passed or failed the quality threshold (PASSorFAIL).dimensions: An array of dimension scores for the column. Each dimension score includes:name: The name of the dimension.score: The score for the dimension, ranging from [0, 100].status: The status of the dimension for the column, indicating if it passed or failed the quality threshold (PASS,FAIL,UNKNOWN, orNOT_APPLICABLE).
details(optional map): Key-value pairs providing additional context about the evaluation.evaluatedAssetCount(optional integer): The number of assets evaluated.
When you run the command to attach an aspect, it replaces any existing data for
that specific aspect. For example, if you update a scorecard that has a score of
80 with a new file showing a score of 90, the 80 is overwritten. It does
not merge the data.
To attach a data quality scorecard, follow these steps:
gcloud
To update aspects for an entry, use the gcloud dataplex entries
update-aspects
command.
Create a JSON file (
dq-aspect.json) with the following content.{ "dataplex-types.global.data-quality-scorecard": { "data": { "score": 80, "status": "PASS", "dimensions": [ { "name": "completeness", "score": 90, "status": "PASS" }, { "name": "uniqueness", "score": 70, "status": "FAIL" } ], "columns": [ { "name": "col1", "score": 85, "status": "PASS" } ] } } }Run the following command:
gcloud dataplex entries update-aspects ENTRY_ID \ --location=LOCATION \ --entry-group=ENTRY_GROUP_ID \ --project=PROJECT_ID \ --aspects=dq-aspect.json
Replace the following variables:
ENTRY_ID: the ID of the entry—for example,example-entryLOCATION: the location of the entry—for example,us-central1ENTRY_GROUP_ID: the ID of the entry group—for example,example-entry-groupPROJECT_ID: the ID of the project—for example,example-project
REST
To update aspects for an entry, use the
entry.patch
method.
Create a file named
payload.jsonand paste the JSON content from your request into it.{ "aspects": { "dataplex-types.global.data-quality-scorecard": { "data": { "score": 80, "status": "PASS", "dimensions": [ { "name": "completeness", "score": 90, "status": "PASS" }, { "name": "uniqueness", "score": 70, "status": "FAIL" } ], "columns": [ { "name": "col1", "score": 85, "status": "PASS" } ] } } } }Run this command in your terminal:
curl -X PATCH \ -H "Authorization: Bearer $(gcloud auth print-access-token)" \ -H "Content-Type: application/json" \ -d @payload.json \ "https://dataplex.googleapis.com/v1/projects/<var>PROJECT_ID</var>/locations/<var>LOCATION</var>/entryGroups/<var>ENTRY_GROUP_ID</var>/entries/<var>ENTRY_ID</var>?updateMask=aspects"Replace the following:
PROJECT_ID: the ID of the project—for example,example-projectLOCATION: the location of the entry—for example,us-central1ENTRY_GROUP_ID: the ID of the entry group—for example,example-entry-groupENTRY_ID: the ID of the entry—for example,example-entry
Other reusable aspect types
The following system aspect types are also available for entry enrichment. The frontloaded summaries are listed in the following sections. Click each expandable section to view field schemas and example JSON payloads.
Contacts (dataplex-types.global.contacts)
Use the contacts aspect type to assign ownership, stewardship, or operational roles to entries.
identities(array): A list of contacts. Each contact includesrole(for example,owner,steward,producer, oradmin),name, andid(email address).
Example payload (REST API):
{ "aspects": { "dataplex-types.global.contacts": { "data": { "identities": [ { "role": "steward", "name": "Jane Doe", "id": "jane.doe@example.com" } ] } } } }
Data profile (dataplex-types.global.data-profile)
Use the data-profile aspect type to capture statistical profiling results generated from source data scans. For more information, see About data profiling.
sourceDataInfo(record): Metadata about the scan, includingscope(PREVIEW,SAMPLED, orALL),scannedRows, andsamplingPercentage.fields(map): Column-level statistics, includingnullness,uniqueness, and type-specific metrics for numeric, string, datetime, and array columns.
Example payload (REST API):
{ "aspects": { "dataplex-types.global.data-profile": { "data": { "sourceDataInfo": { "scope": "ALL", "scannedRows": 100 }, "fields": { "col1": { "nullness": 0.0, "uniqueness": 0.1, "string": { "length": { "min": 1, "max": 20, "avg": 12.54 } } } } } } } }
Generic (dataplex-types.global.generic)
Use the generic aspect type to capture freeform entry information and source system metadata without defining a custom aspect schema.
type(string): A user-specified entry categorization string.system(string): The source system identifier of the custom entry.
Example payload (REST API):
{ "aspects": { "dataplex-types.global.generic": { "data": { "type": "custom-type", "system": "custom-system" } } } }
Overview (dataplex-types.global.overview)
Use the overview aspect type to provide human-readable rich text documentation and helpful external links.
content(string): Rich text description supporting HTML formatting.links(array): External resources and documentation links, each containingurlandtitle.
Example payload (REST API):
{ "aspects": { "dataplex-types.global.overview": { "data": { "content": "This is a rich text description.", "links": [ { "url": "https://example.com", "title": "Example Link" } ] } } } }
Schema (dataplex-types.global.schema)
Use the schema aspect type to describe the tabular schema, column names, modes, and data types of data assets.
fields(array): List of columns, each containingname,dataType,metadataType(such asSTRING,BOOLEAN),mode(NULLABLE,REQUIRED,REPEATED), and optionaldescription.
Example payload (REST API):
{ "aspects": { "dataplex-types.global.schema": { "data": { "fields": [ { "name": "id", "dataType": "string", "metadataType": "STRING", "mode": "REQUIRED" } ] } } } }
Usage (dataplex-types.global.usage)
Use the usage aspect type to track consumption metrics, view counts, and time-series query patterns.
metrics(array): Consumption metrics, each containingname(such asviewsorreads) andtimeSeriesdata points with aggregation intervals and values.refreshTime(datetime): Timestamp when usage metrics were last computed.
Example payload (REST API):
{ "aspects": { "dataplex-types.global.usage": { "data": { "metrics": [ { "name": "views", "timeSeries": [ { "interval": "30d", "value": 100 } ] } ], "refreshTime": "2025-01-01T12:00:00Z" } } } }
Create an entry link
You can establish a relationship between two entries by creating an entry link.
An entry link can be symmetric such as a synonym or asymmetric such as a
definition.
C#
C#
Before trying this sample, follow the C# setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog C# API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Go
Go
Before trying this sample, follow the Go setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Go API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Java
Java
Before trying this sample, follow the Java setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Java API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Node.js
Node.js
Before trying this sample, follow the Node.js setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Node.js API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Python
Python
Before trying this sample, follow the Python setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Python API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
REST
To create an entry link with the required aspect, use the entryLinks.create method, including the aspect data in the request body.
Add aspects to an entry link
To enrich metadata with information about relationships between the entries, add aspects to entry links.
You can configure entry link types to require a specific aspect. When you create an entry link of such type, you must provide the required aspect.
You can add these aspects when you create an entry link, or by updating an existing entry link, as follows:
C#
C#
Before trying this sample, follow the C# setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog C# API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Go
Go
Before trying this sample, follow the Go setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Go API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Java
Java
Before trying this sample, follow the Java setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Java API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Node.js
Node.js
Before trying this sample, follow the Node.js setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Node.js API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Python
Python
Before trying this sample, follow the Python setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Python API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
REST
To update an entry link, use the entryLinks.patch method, including the aspect data in the entryLink body.
Note the following limitations for using aspects with entry links:
- Optional aspects aren't supported.
- Data aspects are not supported.
- Aspects of custom types aren't supported.
- You can only manage required aspects defined by system aspect types, for example,
schema-join. - Searching for entry links based on the content of their aspects isn't supported.
- Importing or exporting entry link aspects isn't supported.
Manage existing aspects for an entry
This section describes how to update and delete the existing aspects for an entry.
Update an aspect
You can edit the optional aspects for both custom entries and system entries. You can edit the required aspects only for custom entries.
For first-party (1P) system entries, such as BigQuery tables, you can update aspects using the modifyEntry API. This lets you use the source system's metadata update permissions (for example, BigQuery Data Editor (roles/bigquery.dataEditor)).
Console
In the Google Cloud console, go to the Knowledge Catalog Search page.
Search for the entry whose aspects you want to update, and click the entry.
The entry details page opens.
- Click the Details tab.
- In the Aspects section, expand the aspect that you want to update, and click Edit.
- In the Edit aspect window, update the required fields.
- Click Save.
gcloud
To update aspects for an entry or a column of an entry, use the gcloud
dataplex entries update
command or gcloud dataplex entries update-aspects.
To update aspects using a JSON file:
gcloud dataplex entries update-aspects ENTRY_ID \ --location=LOCATION \ --entry-group=ENTRY_GROUP_ID \ --project=PROJECT_ID \ --aspects=ASPECTS_JSON_FILE
Replace the following:
ENTRY_ID: the ID of the entry.LOCATION: the location of the entry.ENTRY_GROUP_ID: the ID of the entry group.PROJECT_ID: the ID of the project.ASPECTS_JSON_FILE: the path to the JSON file containing the aspect map.
C#
C#
Before trying this sample, follow the C# setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog C# API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Go
Go
Before trying this sample, follow the Go setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Go API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Java
Java
Before trying this sample, follow the Java setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Java API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Node.js
Node.js
Before trying this sample, follow the Node.js setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Node.js API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Python
Python
Before trying this sample, follow the Python setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Python API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Ruby
Ruby
Before trying this sample, follow the Ruby setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Ruby API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
REST
To update aspects for an entry or a column of an entry, use the
entry.patch
method.
Delete an aspect
Console
In the Google Cloud console, go to the Knowledge Catalog Search page.
Search for the entry whose aspects you want to delete, and click the entry.
The entry details page opens.
- Click the Details tab.
- In the Aspects section, expand the aspect that you want to delete, click Delete.
- Click Confirm.
gcloud
To delete an aspect for an entry, use the gcloud dataplex entries update
command with the --remove-aspects flag.
To delete an entry-level aspect:
gcloud dataplex entries update ENTRY_ID \ --location=LOCATION \ --entry-group=ENTRY_GROUP_ID \ --project=PROJECT_ID \ --remove-aspects='ASPECT_TYPE'
To delete a column-level aspect:
gcloud dataplex entries update ENTRY_ID \ --location=LOCATION \ --entry-group=ENTRY_GROUP_ID \ --project=PROJECT_ID \ --remove-aspects='ASPECT_TYPE@Schema.COLUMN_NAME'
Replace the following:
ENTRY_ID: the ID of the entry.LOCATION: the location of the entry.ENTRY_GROUP_ID: the ID of the entry group.PROJECT_ID: the ID of the project.ASPECT_TYPE: the full aspect type identifier—for example,dataplex-types.global.genericor<var>PROJECT_ID</var>.<var>LOCATION</var>.<var>ASPECT_TYPE_ID</var>.COLUMN_NAME: the name of the column.
C#
C#
Before trying this sample, follow the C# setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog C# API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Go
Go
Before trying this sample, follow the Go setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Go API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Java
Java
Before trying this sample, follow the Java setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Java API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Node.js
Node.js
Before trying this sample, follow the Node.js setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Node.js API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Python
Python
Before trying this sample, follow the Python setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Python API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Ruby
Ruby
Before trying this sample, follow the Ruby setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Ruby API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
REST
To delete an aspect for an entry, use the
entry.patch
method.
Manage existing aspects for an entry link
This section describes how to update the existing aspects for an entry link.
Update an aspect
For entry links, you can only update required aspects that use reusable system aspect types.
For more information, see IAM permissions for entry links operations.
REST
To update an entry link with the required aspect, use the entryLinks.patch method, including the aspect data in the request body.
Delete an aspect
You can't delete required aspect for an entry link.
Manage aspect types
This section describes how to view aspect types, and update and delete custom aspect types.
View the list of available aspect types
Console
In the Google Cloud console, go to the Knowledge Catalog Metadata types page.
Click the Aspect types tab.
This page lists all the available Knowledge Catalog aspect types.
- To view custom aspect types, click the Custom tab. In the Custom tab, the Catalog source column displays where the resource resides in Knowledge Catalog.
To view system aspect types, click the System tab.
For more information about custom and system aspect types, see the categories of aspect types section of this document.
- Optional: To view the list of aspect types in your selected project, click the Custom tab, and then click the Show from all projects toggle to the off position.
The Show from all projects toggle is on by default, and the list includes Knowledge Catalog resources from your selected organization.
gcloud
To list all the available aspect types, use the gcloud dataplex
aspect-types list
command.
C#
C#
Before trying this sample, follow the C# setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog C# API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Go
Go
Before trying this sample, follow the Go setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Go API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Java
Java
Before trying this sample, follow the Java setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Java API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Node.js
Node.js
Before trying this sample, follow the Node.js setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Node.js API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Python
Python
Before trying this sample, follow the Python setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Python API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Ruby
Ruby
Before trying this sample, follow the Ruby setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Ruby API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
REST
To list all the available aspect types, use the
aspectTypes.list
method.
View details of an aspect type
Console
In the Google Cloud console, go to the Knowledge Catalog Metadata types page.
Click the Aspect types tab.
To view the details of a Knowledge Catalog aspect type, click the aspect type. The aspect type details page opens, where you can access details, such as display name, aspect type ID, description, project ID, location, labels, creation date, and last modified date.
- To view the structure of the selected aspect type, click the Template tab.
- To view the list of 10 related entries created recently, click the Sample entries tab.
- To search for all related entries, click Show all related entries in Search. This button appears only if there's at least one related entry.
gcloud
To get the details of an aspect type, use the gcloud dataplex aspect-types
describe command.
C#
C#
Before trying this sample, follow the C# setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog C# API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Go
Go
Before trying this sample, follow the Go setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Go API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Java
Java
Before trying this sample, follow the Java setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Java API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Node.js
Node.js
Before trying this sample, follow the Node.js setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Node.js API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Python
Python
Before trying this sample, follow the Python setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Python API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Ruby
Ruby
Before trying this sample, follow the Ruby setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Ruby API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
REST
To get the details of an aspect type, use the
aspectTypes.get
method.
Update a custom aspect type
You can update the display name, description, template fields, and labels of a custom aspect type. You can't delete an existing field in a template.
You can't update the aspect type ID and location after you create the aspect type.
Console
In the Google Cloud console, go to the Knowledge Catalog Metadata types page.
Click the Aspect types tab.
Click the aspect type that you want to update.
On the Aspect type details page, click Edit.
Edit the display name, description, template fields, and labels, as required.
Optional: To mark a field in the aspect type as deprecated, follow these steps:
- In the Template section, expand the field.
- Select Is Deprecated.
- In the Deprecation reason field, enter a reason for deprecating the selected field.
Click Done.
Click Save.
gcloud
To update a custom aspect type, use the gcloud dataplex aspect-types
update command.
C#
C#
Before trying this sample, follow the C# setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog C# API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Go
Go
Before trying this sample, follow the Go setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Go API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Java
Java
Before trying this sample, follow the Java setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Java API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Node.js
Node.js
Before trying this sample, follow the Node.js setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Node.js API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Python
Python
Before trying this sample, follow the Python setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Python API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Ruby
Ruby
Before trying this sample, follow the Ruby setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Ruby API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
REST
To update a custom aspect type, use the
aspectTypes.patch
method.
Delete a custom aspect type
Console
In the Google Cloud console, go to the Knowledge Catalog Metadata types page.
Click the Aspect types tab.
Click the aspect type that you want to delete.
On the Aspect type details page, click Delete. Confirm when prompted.
gcloud
To delete a custom aspect type, use the gcloud dataplex aspect-types
delete command.
C#
C#
Before trying this sample, follow the C# setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog C# API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Go
Go
Before trying this sample, follow the Go setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Go API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Java
Java
Before trying this sample, follow the Java setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Java API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Node.js
Node.js
Before trying this sample, follow the Node.js setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Node.js API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Python
Python
Before trying this sample, follow the Python setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Python API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
Ruby
Ruby
Before trying this sample, follow the Ruby setup instructions in the Knowledge Catalog quickstart using client libraries. For more information, see the Knowledge Catalog Ruby API reference documentation.
To authenticate to Knowledge Catalog, set up Application Default Credentials. For more information, see Set up authentication for a local development environment.
REST
To delete an existing custom aspect type, use the
aspectTypes.delete
method.
What's next
- Learn how to search for resources in Knowledge Catalog.
- Learn how to manage entries and ingest custom sources.
- Learn how to import metadata into Knowledge Catalog.
- Learn more about metadata in Knowledge Catalog.
- Learn how to establish foundational data context.
- Try Knowledge Catalog use cases.